#include <vector>
using std::vector;

template <typename Type> 
void matrixMultiply(const vector<vector<Type> >& firstOp,
			  const vector<vector<Type> >& secondOp,
			  vector<vector<Type> >& result)
{
    int nRows = firstOp.size();
    int nColumns = nRows;

    // for every row in the first op
    for(int row=0; row<nRows; ++row)
    {
	    // for every column in the second op
	    for(int column=0;column<nColumns; ++column)
	    {
		result[row][column] = 0;
		for(int i=0;i<nRows;i++)
		{
			result[row][column] = result[row][column] +
				firstOp[row][i] * secondOp[i][column];
		}
	    }
    }
}
